SystemOrganization addCategory: #ConfigurationOfGRID!

Object subclass: #ConfigurationOfGRID
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGRID'!

!ConfigurationOfGRID class methodsFor: 'private' stamp: 'carlaGriggio 11/21/2011 16:07'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfGRID class methodsFor: 'private' stamp: 'carlaGriggio 11/21/2011 16:07'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfGRID class methodsFor: 'metacello tool support' stamp: 'carlaGriggio 11/21/2011 16:07'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGRID class methodsFor: 'metacello tool support' stamp: 'carlaGriggio 11/21/2011 16:07'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfGRID class methodsFor: 'loading' stamp: 'carlaGriggio 11/21/2011 16:07'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfGRID class methodsFor: 'metacello tool support' stamp: 'carlaGriggio 11/21/2011 16:07'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfGRID class methodsFor: 'accessing' stamp: 'carlaGriggio 11/21/2011 16:07'!
project

	^self new project! !

!ConfigurationOfGRID class methodsFor: 'unloading Metacello' stamp: 'carlaGriggio 11/21/2011 16:07'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfGRID methodsFor: 'baselines' stamp: 'LDM 7/19/2013 16:50'!
baseline01: spec 
	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/GRID'.	
		spec 
			package: 'GRID-Core';
			package: 'GRID-Forms' with:[spec requires:#('Seaside30')];
			package: 'GRID-UI' with:[spec requires: #('GRID-Core' 'Seaside30' 'GRID-Forms')];
			package: 'GRID-Tests' with:[spec requires: #('GRID-Core')];
			package: 'GRID-Example-Model' with:[spec requires: #('GRID-Core')];
			package: 'GRID-Example-Reports' with:[spec requires: #('GRID-Core' 'GRID-Example-Model')];
			package: 'GRID-Example-UI' with:[spec requires: #('GRID-Core' 'GRID-UI' 'GRID-Example-Model')];
			package:'JQuery-UI' with:[spec
				repository:'http://www.squeaksource.com/Seaside30';
				requires: #('Seaside30')];
			group: 'default' with: #('Core and Examples');
			group: 'Core' with: #('GRID-Core' 'GRID-UI' 'GRID-Tests');
			group: 'Core and Examples' with: #('Core' 'GRID-Example-Model' 'GRID-Example-Reports' 'GRID-Example-UI').
		].
	spec for: #gemstone do:[
		spec project: 'Seaside30' with: [
			spec
				className: 'ConfigurationOfSeaside30';
				versionString: '3.0.6';
				loads: #('Base' 'Seaside-Adaptors-FastCGI' 'Javascript-Core' 'JQuery-Core' 'JQuery-UI');
				repository: 'http://seaside.gemstone.com/ss/MetacelloRepository' ]
		].
	spec for: #pharo do:[
		spec project: 'Seaside30' with: [
			spec
				className: 'ConfigurationOfSeaside30';
				versionString: '3.0.6';
				loads: #('Base' 'Javascript-Core' 'JQuery-Core' 'JQuery-UI');
				repository: 'http://www.squeaksource.com/MetacelloRepository' ]
		]
	
! !

!ConfigurationOfGRID methodsFor: 'accessing' stamp: 'carlaGriggio 11/21/2011 16:07'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 03/19/2012 12:19'!
version011: spec
	<version: '0.11' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.13';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.6';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.5';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.3';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.7';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.5' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 03/19/2012 12:15'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.11';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.6';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.2';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.1';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.3';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.5';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.4' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 5/18/2012 18:41'!
version020: spec
	<version: '0.20' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.16';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.9';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.7';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.3';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.10';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 6/12/2012 02:09'!
version021: spec
	<version: '0.21' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.22';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.12';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.15';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.3';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.10';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 7/11/2012 17:33'!
version022: spec
	<version: '0.22' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.40';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.12';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.26';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.5';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.10';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6';
				package: 'JQuery-UI' with:'JQuery-UI-lr.69' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 07/16/2012 05:35'!
version023: spec
	<version: '0.23' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Baseline for a full ajax report edition and creation';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.43';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.12';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.27';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.5';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.10';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6';
				package: 'JQuery-UI' with:'JQuery-UI-lr.69' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'carlaGriggio 8/27/2012 17:56'!
version024: spec
	<version: '0.24' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Stable version before final refactors';
				package: 'GRID-Core' with: 'GRID-Core-carlaGriggio.54';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.12';
				package: 'GRID-UI' with: 'GRID-UI-carlaGriggio.36';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.5';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.10';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6';
				package: 'JQuery-UI' with:'JQuery-UI-lr.69' ]! !

!ConfigurationOfGRID methodsFor: 'versions' stamp: 'LDM 7/19/2013 16:16'!
version025: spec
	<version: '0.25' imports: #('0.1-baseline')>
	spec
		for: #common
		
		do: [ 
			spec
				blessing: #development;
				description: 'Stable version before final refactors';
				package: 'GRID-Core' with: 'GRID-Core-LDM.58';
				package: 'GRID-Forms' with: 'GRID-Forms-carlaGriggio.14';
				package: 'GRID-UI' with: 'GRID-UI-LDM.40';
				package: 'GRID-Tests' with: 'GRID-Tests-carlaGriggio.2';
				package: 'GRID-Example-Model' with: 'GRID-Example-Model-carlaGriggio.5';
				package: 'GRID-Example-Reports' with: 'GRID-Example-Reports-carlaGriggio.11';
				package: 'GRID-Example-UI' with: 'GRID-Example-UI-carlaGriggio.6';
				package: 'JQuery-UI' with:'JQuery-UI-lr.69' ]! !
